/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PREB                                                     */
/* Tabela : PRECOBASE                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 28/01/2004 - Raphael Freitas Pinheiro                                      */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_PREB
BEFORE INSERT OR UPDATE OR DELETE
ON PRECOBASE FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUPRBA := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDPRECOBASE,0) <> NVL(:NEW.CDPRECOBASE,0)) THEN
         :NEW.DTULTATUPRBA := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('PRECOBASE', '', 'CDPRECOBASE='||:OLD.CDPRECOBASE||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE PRECOBASE MODIFY DTULTATUPRBA DEFAULT SYSDATE
/
