CREATE OR REPLACE
PROCEDURE EXP_ITEMAUTFOL_NGD
IS
  V_CHAVE        VARCHAR2(300);
  V_ERRO         VARCHAR2(300);
  V_CONTADOR     FLOAT := 0;
  V_CONTAFORN    FLOAT := 0;
  V_CDFORNCED    FORNECEDOR.CDFORNECED%TYPE := '_';
  V_TXOBSITMAF   USR_ITEMAUTFOL_NGD.TXOBSITMAF%TYPE;
BEGIN
   FOR C_FILIALOL IN
      (SELECT CDFILIAL CDFILIOPELOG, NMFILIAL, CDREGIAO
         FROM FILIAL
        WHERE NVL(FILIAL.IDCNTRRESC, 'N') <> 'S'
          AND NVL(FILIAL.IDFUNCAOFILI, 'T') = 'O')
   LOOP
      FOR C_PRODUTOS IN
         (SELECT ITEMAUTF.NRAUTOFORN, C_FILIALOL.CDFILIOPELOG CDFILIOPELOG, TO_CHAR(AUTOFORNE.DTAUTOFORN, 'YYYYMMDD') DTITEMAUTF_NGD,
                 PRODUTOOL.CDARVPROD, 'A' IDITEMAUTFOL, AUTOFORNE.USR_NRPEDIDO, 1 IDEMPRESADEST,
                 TO_CHAR(ITEMAUTF.DTPROGENTAF, 'YYYYMMDD') DTPROGENTAF, NVL(ITEMAUTF.QTPROGENTAF, 0) QTPROGENTAF,
                 NVL(ITEMAUTF.QTEFETENTRAF, 0) QTEFETENTRAF, NULL IDEMPRESAORIG, NULL CDARVPRODORIG,
                 NULL CDFILDEST, NULL DTPEDIDO, NULL QTPEDIDO, NULL QTEXPEDIDA, AUTOFORNE.CDFORNECED
             FROM PRODUTO PRODUTOOL, RELACPRODOL,
                  ITEMAUTF, AUTOFORNE, PRODUTO
            WHERE ITEMAUTF.CDFILDEST      = AUTOFORNE.CDFILDEST
              AND ITEMAUTF.CDFILLANC      = AUTOFORNE.CDFILLANC
              AND ITEMAUTF.NRAUTOFORN     = AUTOFORNE.NRAUTOFORN
              AND ITEMAUTF.CDPRODUTO      = PRODUTOOL.CDPRODUTO
              AND ITEMAUTF.CDPRODUTO      = RELACPRODOL.CDPRODARVOL
              AND RELACPRODOL.CDPRARVORIG = PRODUTO.CDPRODUTO
              AND ITEMAUTF.CDFILDEST      = C_FILIALOL.CDFILIOPELOG
              AND NVL(AUTOFORNE.IDBAIXAAF, '1')    = '1'
              AND NVL(AUTOFORNE.IDSITUATUAAF, '1') = '1'
              AND NVL(AUTOFORNE.IDAFFORALIM, 'N')  = 'N'
              AND NVL(AUTOFORNE.IDAFCONS, 'N')     = 'N'
              AND NVL(AUTOFORNE.IDAFEXPIRADA, 'N') = 'N'
              AND AUTOFORNE.DTAUTOFORN >= SYSDATE - 732
              AND NVL(ITEMAUTF.IDBAIXITMAF, '1')   = '1'
              AND NVL(ITEMAUTF.QTPROGENTAF, 0)     > 0
              AND NVL(ITEMAUTF.QTPROGENTAF, 0)     > NVL(ITEMAUTF.QTEFETENTRAF, 0)
              AND AUTOFORNE.DTAUTOFORN < ITEMAUTF.DTPROGENTAF
         )
      LOOP
         V_CONTADOR := V_CONTADOR + 1;
         IF V_CONTADOR >= 500 THEN
            V_CONTADOR := 0;
            COMMIT;
         END IF;
         SELECT NVL(MAX(USR_ITEMAUTFOL_NGD.CDFORNECED||USR_ITEMAUTFOL_NGD.CDARVPROD), '')
           INTO V_CHAVE
           FROM USR_ITEMAUTFOL_NGD
          WHERE USR_ITEMAUTFOL_NGD.NRAUTOFORN     = C_PRODUTOS.NRAUTOFORN
            AND USR_ITEMAUTFOL_NGD.CDFILIOPELOG   = C_PRODUTOS.CDFILIOPELOG
            AND USR_ITEMAUTFOL_NGD.DTITEMAUTF_NGD = C_PRODUTOS.DTITEMAUTF_NGD
            AND USR_ITEMAUTFOL_NGD.CDARVPROD      = C_PRODUTOS.CDARVPROD
            AND USR_ITEMAUTFOL_NGD.IDITEMAUTFOL   = C_PRODUTOS.IDITEMAUTFOL;
         BEGIN
            IF V_CHAVE = '' THEN
               INSERT
                INTO USR_ITEMAUTFOL_NGD(NRAUTOFORN, CDFILIOPELOG, DTITEMAUTF_NGD, CDARVPROD, IDITEMAUTFOL,
                                        TXOBSITMAF, USR_NRPEDIDO, IDEMPRESADEST, DTPROGENTAF, QTPROGENTAF,
                                        QTEFETENTRAF, IDEMPRESAORIG, CDARVPRODORIG, CDFILDEST,
                                        DTPEDIDO, QTPEDIDO, QTEXPEDIDA, CDFORNECED, IDSTATUSAFOL, IDSTATUSFORFIL,
                                        TPINTERFACE, DTINTERFACEORI,	DTINTERFACEDEST,	STATUS)
               VALUES (C_PRODUTOS.NRAUTOFORN, C_PRODUTOS.CDFILIOPELOG, C_PRODUTOS.DTITEMAUTF_NGD, C_PRODUTOS.CDARVPROD, C_PRODUTOS.IDITEMAUTFOL,
                       V_TXOBSITMAF, C_PRODUTOS.USR_NRPEDIDO, C_PRODUTOS.IDEMPRESADEST, C_PRODUTOS.DTPROGENTAF, C_PRODUTOS.QTPROGENTAF,
                       C_PRODUTOS.QTEFETENTRAF, C_PRODUTOS.IDEMPRESAORIG, C_PRODUTOS.CDARVPRODORIG, C_PRODUTOS.CDFILDEST,
                       C_PRODUTOS.DTPEDIDO, C_PRODUTOS.QTPEDIDO, C_PRODUTOS.QTEXPEDIDA, C_PRODUTOS.CDFORNECED, 'ATIVO', 'ATIVO',
                       'I', 	SYSDATE,	NULL,	'1');
            ELSE
               UPDATE USR_ITEMAUTFOL_NGD
                  SET TXOBSITMAF         = V_TXOBSITMAF,
                      USR_NRPEDIDO       = C_PRODUTOS.USR_NRPEDIDO,
                      IDEMPRESADEST      = C_PRODUTOS.IDEMPRESADEST,
                      DTPROGENTAF        = C_PRODUTOS.DTPROGENTAF,
                      QTPROGENTAF        = C_PRODUTOS.QTPROGENTAF,
                      QTEFETENTRAF       = C_PRODUTOS.QTEFETENTRAF,
                      IDEMPRESAORIG      = C_PRODUTOS.IDEMPRESAORIG,
                      CDARVPRODORIG      = C_PRODUTOS.CDARVPRODORIG,
                      CDFILDEST          = C_PRODUTOS.CDFILDEST,
                      CDFORNECED         = C_PRODUTOS.CDFORNECED,
                      TPINTERFACE        = 'A',
                      DTINTERFACEORI     = SYSDATE,
                      DTINTERFACEDEST    = NULL,
                      STATUS             = '1'
                WHERE USR_ITEMAUTFOL_NGD.NRAUTOFORN     = C_PRODUTOS.NRAUTOFORN
                  AND USR_ITEMAUTFOL_NGD.CDFILIOPELOG   = C_PRODUTOS.CDFILIOPELOG
                  AND USR_ITEMAUTFOL_NGD.DTITEMAUTF_NGD = C_PRODUTOS.DTITEMAUTF_NGD
                  AND USR_ITEMAUTFOL_NGD.CDARVPROD      = C_PRODUTOS.CDARVPROD
                  AND USR_ITEMAUTFOL_NGD.IDITEMAUTFOL   = C_PRODUTOS.IDITEMAUTFOL;
            END IF;
            UPDATE USR_LOG_NGD
               SET DTLOG      = SYSDATE,
                   STATUS     = '0',
                   OBSSTATUS  = NULL
             WHERE IDPROCESSO = 'USR_ITEMAUTFOL_NGD'
               AND IDPESQITEM = C_PRODUTOS.NRAUTOFORN||'-'||
               C_PRODUTOS.CDFILIOPELOG||'-'||C_PRODUTOS.DTITEMAUTF_NGD||'-'||C_PRODUTOS.CDARVPROD||'-'||C_PRODUTOS.IDITEMAUTFOL;
            IF SQL%NOTFOUND THEN
               INSERT
                 INTO USR_LOG_NGD(IDPROCESSO, DTLOG, STATUS, OBSSTATUS, IDPESQITEM)
               VALUES ('USR_ITEMAUTFOL_NGD', SYSDATE, '0', NULL, C_PRODUTOS.NRAUTOFORN||'-'||
               C_PRODUTOS.CDFILIOPELOG||'-'||C_PRODUTOS.DTITEMAUTF_NGD||'-'||C_PRODUTOS.CDARVPROD||'-'||C_PRODUTOS.IDITEMAUTFOL);
            END IF;
         EXCEPTION
            WHEN OTHERS THEN BEGIN
               V_ERRO := SUBSTR(SQLERRM(SQLCODE), 1, 300);
               UPDATE USR_LOG_NGD
                  SET DTLOG      = SYSDATE,
                      STATUS     = '1',
                      OBSSTATUS  = V_ERRO
                WHERE IDPROCESSO = 'USR_ITEMAUTFOL_NGD'
                  AND IDPESQITEM = C_PRODUTOS.NRAUTOFORN||'-'||
                  C_PRODUTOS.CDFILIOPELOG||'-'||C_PRODUTOS.DTITEMAUTF_NGD||'-'||C_PRODUTOS.CDARVPROD||'-'||C_PRODUTOS.IDITEMAUTFOL;
               IF SQL%NOTFOUND THEN
                  INSERT
                    INTO USR_LOG_NGD(IDPROCESSO, DTLOG, STATUS, OBSSTATUS, IDPESQITEM)
                  VALUES ('USR_ITEMAUTFOL_NGD', SYSDATE, '1', V_ERRO, C_PRODUTOS.NRAUTOFORN||'-'||
                  C_PRODUTOS.CDFILIOPELOG||'-'||C_PRODUTOS.DTITEMAUTF_NGD||'-'||C_PRODUTOS.CDARVPROD||'-'||C_PRODUTOS.IDITEMAUTFOL);
               END IF;
            END;
         END;
      END LOOP;
   END LOOP;
   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('EXP_ITEMAUTFOL_NGD','6.39.030'); END;
/
