<?php
namespace Zeedhi\DevOps\Model\Projectmanagement\Repositories;

use Doctrine\DBAL\Sharding\SQLAzure\SQLAzureFederationsSynchronizer;
use Doctrine\ORM\EntityRepository;

class Available extends EntityRepository {

    public function getAvailableByResource($organization,$resource){
        $sql = <<<SQL
              SELECT A.BEGIN, A.END FROM
                      RESOURCE_T R
                      LEFT JOIN AVAILABLE A ON (R.ID = A.RESOURCE_T)
                          WHERE A.RESOURCE_T = :resource
                        AND R.ORGANIZATION = :organization
SQL;

        $params = array(
            'resource' => $resource,
            'organization' => $organization
        );
        return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);
    }


}