import { DatasourceFactory } from '@zeedhi/core';
import { TekRestDatasource } from '@zeedhi/teknisa-components-common';
import { IRestSelectForm } from '@/services/datasources/interfaces';

// Defines a new class to handle datasource using localstorage
export class RestSelectForm extends TekRestDatasource implements IRestSelectForm {
    [key: string]: any;

    // public test!: IDictionary;

    // constructor(props: IRestSelectForm) {
    //     super({ ...props, lazyLoad: true });
    //
    //     if (!this.watchUrl) {
    //         this.test = this.getInitValue('test', props.test, {});
    //     }
    // }

    /**
     * Retrieves request params
     */
    protected getRequestParams(): any {
        const requestParams = super.getRequestParams();
        requestParams.find = {};
        requestParams.find.value = this.search;
        requestParams.find.column = this.searchIn[0];
        delete requestParams.search;
        delete requestParams.search_in;
        return requestParams;
    }

    public clone() {
        return {
            ...super.clone(),
            type: 'restSelectForm',
        };
    }
}

// Register the class in DatasourceFactory
DatasourceFactory.register('restSelectForm', RestSelectForm);
